<id>
Board Character Limits YaBB 2.6.0
</id>

<version>
0.4
</version>

<mod info>
This mod adds Board specific character limits for Users and Admins

Version History
---------------
0.1 alpha - First release - February 22, 2014
0.2 alpha - release - March 3, 2014
0.3 alpha - release - Apri1 6, 2014 (Fixes for 2.6.0. build 1470)
0.4 - release Aug 14, 2014 (Fixes for Mod Hooks, Build 1530)

For YaBB 2.6.0

Instructions:

Apply the mod and upload (in ASCII mode):

cgi-bin/yabb2/Admin/Modlist.pm
cgi-bin/yabb2/Admin/ManageBoards.pm
cgi-bin/yabb2/Languages/English/Admin.lng
cgi-bin/yabb2/Sources/Load.pm
cgi-bin/yabb2/Sources/Post.pm
</mod info>

<author>
Dandello
</author>

<homepage>
http://www.yabbforumsoftware.com/cgi-bin/yabb2/YaBB.pl
</homepage>

<edit file>
Admin/ModList.pm
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
    $boardcharlimits = q~Board_Character_Limits_YaBB260|Dandello|Set board specific character limits for members and Admins|0.3 alpha|04/16/14~;
    push @installed_mods, "$boardcharlimits";
</add before>

<edit file>
Admin/ManageBoards.pm
</edit file>

<search for>
                        <td class="windowbg2"><label for="rbin$i"><b>$admin_txt{'64i'}</b></label></td>
                        <td class="windowbg2" colspan="3"><input type="checkbox" id="rbin$i" name="rbin$i" value="1" $rbinch onclick="javascript: if (this.checked) checkbin(true, '$i'); else checkbin(false, '$i');" /> <label for="rbin$i">$admin_txt{'64j'}</label></td>
                    </tr><tr>
</search for>

<add after>
                        <td class="catbg"  colspan="4"><b>$admin_txt{'chars'}:</b></td>
                    </tr><tr>~;

    my $mychar_u = ${ $uid . $id }{'brdchar_u'} || $MaxMessLen;
    my $mychar_a = ${ $uid . $id }{'brdchar_a'} || $AdMaxMessLen;

    $yymain .= qq~
                        <td class="windowbg"><label for="chars$i"><b>$admin_txt{'chars_u'}</b></label></td>
                        <td class="windowbg2" colspan="3"><input type="text" name="chars_u$i" id="chars_u$i" value="$mychar_u" size="20" maxlength="6" /></td>
                    </tr><tr>
                        <td class="windowbg"><label for="chars_a$i"><b>$admin_txt{'chars_a'}</b></label></td>
                        <td class="windowbg2" colspan="3"><input type="text" name="chars_a$i" id="chars_a$i" value="$mychar_a" size="20" maxlength="6" /></td>
                    </tr><tr>
</add after>

<search for>
        if ( $FORM{"maxage$i"} && $FORM{"maxage$i"} < $FORM{"minage$i"} ) {
            $FORM{"maxage$i"} = $FORM{"minage$i"};
        }
</search for>

<add after>
### Board Char limits Start
         if ( $FORM{"chars_u$i"} eq q{} ) { $FORM{"chars_u$i"} = $MaxMessLen; }
         if ( $FORM{"chars_a$i"} eq q{} ) { $FORM{"chars_a$i"} = $AdMaxMessLen; }
###Board Char limits end
</add after>

<search for>
        );
        ## BRD Mod Hook ##
</search for>

<add before>
            $FORM{"chars_u$i"},
            $FORM{"chars_a$i"},
</add before>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
'brdrss3' => 'Check to show RSS Feed for this board on the Board Index.<br /><b>Note:</b> Only relevant if RSS is enabled and the board is not an external link board.',
</search for>

<add after>
'chars' => 'Set Board specific character limits on Posts',
'chars_u' => 'Member Limits:',
'chars_a' => 'Admin Limits:',
</add after>

<edit file>
Sources/Load.pm
</edit file>

<search for>
            ## Mod Hook 1 ##
</search for>

<add before>
 $brdchar_u, $brdchar_a,
</add before>

<search for>
             ## Mod Hook 2 ##
</search for>

<add before>
            'brdchar_u'     => $brdchar_u,
            'brdchar_a'     => $brdchar_a,
</add before>

<edit file>
Sources/Post.pm
</edit file>

<search for>
    # Figure out the name of the category
    get_forum_master();
    ( $cat, $catperms ) = split /\|/xsm, $catinfo{$curcat};
    ToChars($cat);
</search for>

<add after>

    if ( ($iamadmin || $iamgmod) && ${ $uid . $currentboard }{'brdchar_a'} ) {
        $MaxMessLen = ${ $uid . $currentboard }{'brdchar_a'};
    }
    if ( (!$iamadmin && !$iamgmod) && ${ $uid . $currentboard }{'brdchar_u'} ) {
        $MaxMessLen = ${ $uid . $currentboard }{'brdchar_u'};
    }
</add after>

<search for>
        $tmpmusername = $thismusername;
</search for>

<add after>
        if ( ($iamadmin || $iamgmod) && ${ $uid . $currentboard }{'brdchar_a'} ) {
            $MaxMessLen = ${ $uid . $currentboard }{'brdchar_a'};
        }
        if ( (!$iamadmin && !$iamgmod) && ${ $uid . $currentboard }{'brdchar_u'} ) {
            $MaxMessLen = ${ $uid . $currentboard }{'brdchar_u'};
        }
</add after>